"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactDom = require("react-dom");

var _cloudimageResponsiveUtils = require("cloudimage-responsive-utils");

var _utils = require("./utils.js");

var _reactLazyload = _interopRequireDefault(require("react-lazyload"));

var _excluded = ["className", "style", "lazyLoadConfig", "lazyLoading", "children"],
    _excluded2 = ["onImgLoad", "alt"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var BackgroundImg = /*#__PURE__*/function (_Component) {
  _inherits(BackgroundImg, _Component);

  var _super = _createSuper(BackgroundImg);

  function BackgroundImg(props) {
    var _this;

    _classCallCheck(this, BackgroundImg);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "processBg", function (update, windowScreenBecomesBigger) {
      var bgNode = !_this.server ? (0, _reactDom.findDOMNode)(_assertThisInitialized(_this)) : null;
      var data = (0, _cloudimageResponsiveUtils.processReactNode)(_this.props, bgNode, update, windowScreenBecomesBigger);

      if (!data) {
        return;
      }

      _this.setState(data);
    });

    _this.server = (0, _cloudimageResponsiveUtils.isServer)();
    _this.state = {
      cloudimgURL: '',
      processed: false
    };
    return _this;
  }

  _createClass(BackgroundImg, [{
    key: "UNSAFE_componentWillMount",
    value: function UNSAFE_componentWillMount() {
      if (this.server) {
        this.processBg();
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.server) return;
      this.processBg();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.server) return;
      var _this$props = this.props,
          _this$props$config = _this$props.config;
      _this$props$config = _this$props$config === void 0 ? {} : _this$props$config;
      var innerWidth = _this$props$config.innerWidth,
          src = _this$props.src;

      if (prevProps.config.innerWidth !== innerWidth) {
        this.processBg(true, innerWidth > prevProps.config.innerWidth);
      }

      if (src !== prevProps.src) {
        this.processBg();
      }
    }
  }, {
    key: "render",
    value: function render() {
      if (this.server) return /*#__PURE__*/_react["default"].createElement("div", null, this.props.children);
      var _this$state = this.state,
          height = _this$state.height,
          processed = _this$state.processed,
          cloudimgURL = _this$state.cloudimgURL,
          previewCloudimgURL = _this$state.previewCloudimgURL,
          preview = _this$state.preview;
      var _this$props2 = this.props,
          _this$props2$config = _this$props2.config,
          config = _this$props2$config === void 0 ? {} : _this$props2$config,
          onImgLoad = _this$props2.onImgLoad,
          src = _this$props2.src;

      var _getFilteredBgProps = (0, _utils.getFilteredBgProps)(this.props),
          className = _getFilteredBgProps.className,
          style = _getFilteredBgProps.style,
          lazyLoadConfig = _getFilteredBgProps.lazyLoadConfig,
          _getFilteredBgProps$l = _getFilteredBgProps.lazyLoading,
          lazyLoading = _getFilteredBgProps$l === void 0 ? config.lazyLoading : _getFilteredBgProps$l,
          children = _getFilteredBgProps.children,
          otherProps = _objectWithoutProperties(_getFilteredBgProps, _excluded);

      if (!processed) return /*#__PURE__*/_react["default"].createElement("div", null, children);

      var Container = /*#__PURE__*/_react["default"].createElement(BackgroundInner, {
        cloudimgURL: cloudimgURL,
        previewCloudimgURL: previewCloudimgURL,
        className: className,
        style: style,
        children: children,
        preview: preview,
        otherProps: otherProps,
        config: config,
        onImgLoad: onImgLoad,
        src: src
      });

      return lazyLoading ? /*#__PURE__*/_react["default"].createElement(_reactLazyload["default"], _extends({
        height: height,
        offset: config.lazyLoadOffset
      }, lazyLoadConfig), Container) : Container;
    }
  }]);

  return BackgroundImg;
}(_react.Component);

var BackgroundInner = /*#__PURE__*/function (_Component2) {
  _inherits(BackgroundInner, _Component2);

  var _super2 = _createSuper(BackgroundInner);

  function BackgroundInner() {
    var _this2;

    _classCallCheck(this, BackgroundInner);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this2 = _super2.call.apply(_super2, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this2), "state", {
      loaded: false
    });

    _defineProperty(_assertThisInitialized(_this2), "preLoadImg", function (cloudimgURL) {
      var img = new Image();
      img.onload = _this2._onImgLoad;
      img.src = cloudimgURL;
    });

    _defineProperty(_assertThisInitialized(_this2), "_onImgLoad", function () {
      _this2.setState({
        loaded: true
      });

      var onImgLoad = _this2.props.onImgLoad;

      if (typeof onImgLoad === "function") {
        for (var _len2 = arguments.length, params = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
          params[_key2] = arguments[_key2];
        }

        onImgLoad(params);
      }
    });

    _defineProperty(_assertThisInitialized(_this2), "getAlt", function (name) {
      if (!name) {
        return;
      }

      var index = name.indexOf('.');
      return name.slice(0, index);
    });

    return _this2;
  }

  _createClass(BackgroundInner, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this3 = this;

      var _this$props$config2 = this.props.config;
      _this$props$config2 = _this$props$config2 === void 0 ? {} : _this$props$config2;
      var delay = _this$props$config2.delay;

      if (typeof delay !== 'undefined') {
        setTimeout(function () {
          _this3.preLoadImg(_this3.props.cloudimgURL);
        }, delay);
      } else {
        this.preLoadImg(this.props.cloudimgURL);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var loaded = this.state.loaded;
      var _this$props3 = this.props,
          _this$props3$config = _this$props3.config;
      _this$props3$config = _this$props3$config === void 0 ? {} : _this$props3$config;
      var autoAlt = _this$props3$config.autoAlt,
          cloudimgURL = _this$props3.cloudimgURL,
          previewCloudimgURL = _this$props3.previewCloudimgURL,
          className = _this$props3.className,
          style = _this$props3.style,
          children = _this$props3.children,
          preview = _this$props3.preview,
          src = _this$props3.src,
          otherProps = _this$props3.otherProps;

      var onImgLoad = otherProps.onImgLoad,
          alt = otherProps.alt,
          filteredProps = _objectWithoutProperties(otherProps, _excluded2);

      return /*#__PURE__*/_react["default"].createElement("div", _extends({}, filteredProps, {
        alt: !alt && autoAlt ? this.getAlt(src) : alt,
        className: [className, 'cloudimage-background', loaded ? 'loaded' : 'loading'].join(' ').trim(),
        style: _cloudimageResponsiveUtils.backgroundStyles.container({
          style: style,
          cloudimgURL: cloudimgURL
        })
      }), preview && /*#__PURE__*/_react["default"].createElement("div", {
        style: _cloudimageResponsiveUtils.backgroundStyles.previewBgWrapper({
          loaded: loaded
        })
      }, /*#__PURE__*/_react["default"].createElement("div", {
        style: _cloudimageResponsiveUtils.backgroundStyles.previewBg({
          previewCloudimgURL: previewCloudimgURL
        })
      })), preview ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "cloudimage-background-content",
        style: {
          position: 'relative'
        }
      }, children) : children);
    }
  }]);

  return BackgroundInner;
}(_react.Component);

var _default = BackgroundImg;
exports["default"] = _default;